#
# spec file for package ghc-exceptional
#
# Copyright (c) 2016 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name exceptional
Name:           ghc-%{pkg_name}
Version:        0.3.0.0
Release:        1.1
Summary:        Essentially the Maybe type with error messages
License:        BSD-2-Clause
Group:          System/Libraries
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
# Begin cabal-rpm deps:
BuildRequires:  ghc-exceptions-devel
BuildRequires:  ghc-rpm-macros
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# End cabal-rpm deps

%description
This is a very simple type:

> data Exceptional x > = Failure String > | Success x

It's much like 'Maybe', except instead of 'Nothing', we have 'Failure String'.

A comparison could also be made to 'Either String'. I made this library because
I was dissatisfied with the 'Monad' instance for 'Either'. In this type, 'fail
= Failure'. It's rather simple.

Changes

[0.3.0.0] Fix erroneous behavior in 'foldExceptional' function added in version
0.2. This release actually does break (or rather fix) the 'foldExceptional'
function, so be careful.

[0.2.0.0] Add 'exceptional' function to encapsulate ordinary exceptions in the
'Exceptional' monad. Add folding functions.

This release does not actually break the API, however I was rather tired when I
chose the version number. This should be 0.1.6.

[0.1.5.0] Add 'exceptIO' function to encapsulate IO errors in the 'Exceptional'
monad.

[0.1.4.3] Fix bug where 'exceptional' won't compile on 'base < 4.8'.
Also move the changelog back to the description so it's more visible.

[0.1.4.2] Moved change log to a separate file so Hackage displays it correctly.

[0.1.4.1] Documentation enhancements/fixes.

[0.1.4.0] Added 'fromMaybe' and 'toMaybe' functions, and a link to the bug
tracker.

[0.1.3.0] Fixed a typo. 0.1.2.0 won't build. Also added definition of 'empty'
for 'Alternative'.

[0.1.2.0] Added 'fromEither' and 'toEither' functions.

[0.1.1.3] Hackage is terrible. Yet another formatting fix.

[0.1.1.2] Yet another formatting fix.

[0.1.1.1] Formatting fix to the haddock documentation.

[0.1.1.0] Add 'runExceptional' function.

[0.1.0.1] Minor documentation changes. No changes to the API.

[0.1.0.0] Initial version.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}


%build
%ghc_lib_build


%install
%ghc_lib_install


%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%doc README.md

%changelog
* Sun Jul 10 2016 psimons@suse.com
- Update to version 0.3.0.0 revision 0 with cabal2obs.
